from collections.abc import Hashable, Sequence
from typing import Any

import numpy as np
import pandas as pd
import plotly.graph_objs.box.selected as _selected
import plotly.graph_objs.box.unselected as _unselected
from plotly.basedatatypes import BaseTraceType as _BaseTraceType
from plotly.graph_objs.box import (
    Hoverlabel,
    Legendgrouptitle,
    Line,
    Marker,
    Selected,
    Stream,
    Unselected,
)

class Box(_BaseTraceType):
    _parent_path_str = ...
    _path_str = ...
    _valid_props = ...
    @property
    def alignmentgroup(self) -> str | int: ...
    @alignmentgroup.setter
    def alignmentgroup(self, val: str | int) -> None: ...
    @property
    def boxmean(self) -> bool | str: ...
    @boxmean.setter
    def boxmean(self, val: bool | str) -> None: ...
    @property
    def boxpoints(self) -> bool | str: ...
    @boxpoints.setter
    def boxpoints(self, val: bool | str) -> None: ...
    @property
    def customdata(self) -> Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @customdata.setter
    def customdata(
        self, val: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]
    ) -> None: ...
    @property
    def customdatasrc(self) -> str: ...
    @customdatasrc.setter
    def customdatasrc(self, val: str) -> None: ...
    @property
    def dx(self) -> int | float: ...
    @dx.setter
    def dx(self, val: int | float) -> None: ...
    @property
    def dy(self) -> int | float: ...
    @dy.setter
    def dy(self, val: int | float) -> None: ...
    @property
    def fillcolor(self) -> str: ...
    @fillcolor.setter
    def fillcolor(self, val: str) -> None: ...
    @property
    def hoverinfo(self) -> str | Sequence[str]: ...
    @hoverinfo.setter
    def hoverinfo(self, val: str | Sequence[str]) -> None: ...
    @property
    def hoverinfosrc(self) -> str: ...
    @hoverinfosrc.setter
    def hoverinfosrc(self, val: str) -> None: ...
    @property
    def hoverlabel(self) -> Hoverlabel | dict[str, Any]: ...
    @hoverlabel.setter
    def hoverlabel(self, val: Hoverlabel | dict[str, Any]) -> None: ...
    @property
    def hoveron(self) -> str: ...
    @hoveron.setter
    def hoveron(self, val: str) -> None: ...
    @property
    def hovertemplate(
        self,
    ) -> str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]: ...
    @hovertemplate.setter
    def hovertemplate(
        self, val: str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
    ) -> None: ...
    @property
    def hovertemplatesrc(self) -> str: ...
    @hovertemplatesrc.setter
    def hovertemplatesrc(self, val: str) -> None: ...
    @property
    def hovertext(
        self,
    ) -> str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]: ...
    @hovertext.setter
    def hovertext(
        self, val: str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
    ) -> None: ...
    @property
    def hovertextsrc(self) -> str: ...
    @hovertextsrc.setter
    def hovertextsrc(self, val: str) -> None: ...
    @property
    def ids(self) -> Sequence[str] | np.ndarray[tuple[int, ...], np.dtype[np.str_]] | pd.Series[str]: ...
    @ids.setter
    def ids(self, val: Sequence[str] | np.ndarray[tuple[int, ...], np.dtype[np.str_]] | pd.Series[str]) -> None: ...
    @property
    def idssrc(self) -> str: ...
    @idssrc.setter
    def idssrc(self, val: str) -> None: ...
    @property
    def jitter(self) -> int | float: ...
    @jitter.setter
    def jitter(self, val: int | float) -> None: ...
    @property
    def legend(self) -> str: ...
    @legend.setter
    def legend(self, val: str) -> None: ...
    @property
    def legendgroup(self) -> str | int: ...
    @legendgroup.setter
    def legendgroup(self, val: str | int) -> None: ...
    @property
    def legendgrouptitle(self) -> Legendgrouptitle | dict[str, Any]: ...
    @legendgrouptitle.setter
    def legendgrouptitle(self, val: Legendgrouptitle | dict[str, Any]) -> None: ...
    @property
    def legendrank(self) -> int | float: ...
    @legendrank.setter
    def legendrank(self, val: int | float) -> None: ...
    @property
    def legendwidth(self) -> int | float: ...
    @legendwidth.setter
    def legendwidth(self, val: int | float) -> None: ...
    @property
    def line(self) -> Line | dict[str, str | int | float]: ...
    @line.setter
    def line(self, val: Line | dict[str, str | int | float]) -> None: ...
    @property
    def lowerfence(
        self,
    ) -> Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @lowerfence.setter
    def lowerfence(
        self,
        val: Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float],
    ) -> None: ...
    @property
    def lowerfencesrc(self) -> str: ...
    @lowerfencesrc.setter
    def lowerfencesrc(self, val: str) -> None: ...
    @property
    def marker(self) -> Marker | dict[str, Any]: ...
    @marker.setter
    def marker(self, val: Marker | dict[str, Any]) -> None: ...
    @property
    def mean(self) -> Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @mean.setter
    def mean(
        self, val: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]
    ) -> None: ...
    @property
    def meansrc(self) -> str: ...
    @meansrc.setter
    def meansrc(self, val: str) -> None: ...
    @property
    def median(self) -> Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @median.setter
    def median(
        self, val: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]
    ) -> None: ...
    @property
    def mediansrc(self) -> str: ...
    @mediansrc.setter
    def mediansrc(self, val: str) -> None: ...
    @property
    def meta(self) -> Sequence[Any] | dict[str, Any] | np.ndarray[tuple[int, ...], Any]: ...
    @meta.setter
    def meta(self, val: Sequence[Any] | dict[str, Any] | np.ndarray[tuple[int, ...], Any]) -> None: ...
    @property
    def metasrc(self) -> str: ...
    @metasrc.setter
    def metasrc(self, val: str) -> None: ...
    @property
    def name(self) -> str | int: ...
    @name.setter
    def name(self, val: str | int) -> None: ...
    @property
    def notched(self) -> bool: ...
    @notched.setter
    def notched(self, val: bool) -> None: ...
    @property
    def notchspan(self) -> Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @notchspan.setter
    def notchspan(
        self, val: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]
    ) -> None: ...
    @property
    def notchspansrc(self) -> str: ...
    @notchspansrc.setter
    def notchspansrc(self, val: str) -> None: ...
    @property
    def notchwidth(self) -> int | float: ...
    @notchwidth.setter
    def notchwidth(self, val: int | float) -> None: ...
    @property
    def offsetgroup(self) -> str | int: ...
    @offsetgroup.setter
    def offsetgroup(self, val: str | int) -> None: ...
    @property
    def opacity(self) -> int | float: ...
    @opacity.setter
    def opacity(self, val: int | float) -> None: ...
    @property
    def orientation(self) -> str: ...
    @orientation.setter
    def orientation(self, val: str) -> None: ...
    @property
    def pointpos(self) -> int | float: ...
    @pointpos.setter
    def pointpos(self, val: int | float) -> None: ...
    @property
    def q1(self) -> Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @q1.setter
    def q1(
        self, val: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]
    ) -> None: ...
    @property
    def q1src(self) -> str: ...
    @q1src.setter
    def q1src(self, val: str) -> None: ...
    @property
    def q3(self) -> Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @q3.setter
    def q3(
        self, val: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]
    ) -> None: ...
    @property
    def q3src(self) -> str: ...
    @q3src.setter
    def q3src(self, val: str) -> None: ...
    @property
    def quartilemethod(self) -> str: ...
    @quartilemethod.setter
    def quartilemethod(self, val: str) -> None: ...
    @property
    def sd(self) -> Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @sd.setter
    def sd(
        self, val: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]
    ) -> None: ...
    @property
    def sdmultiple(self) -> int | float: ...
    @sdmultiple.setter
    def sdmultiple(self, val: int | float) -> None: ...
    @property
    def sdsrc(self) -> str: ...
    @sdsrc.setter
    def sdsrc(self, val: str) -> None: ...
    @property
    def selected(self) -> Selected | dict[str, _selected.Marker | dict[str, Any]]: ...
    @selected.setter
    def selected(self, val: Selected | dict[str, _selected.Marker | dict[str, Any]]) -> None: ...
    @property
    def selectedpoints(self) -> Sequence[int]: ...
    @selectedpoints.setter
    def selectedpoints(self, val: Sequence[int]) -> None: ...
    @property
    def showlegend(self) -> bool: ...
    @showlegend.setter
    def showlegend(self, val: bool) -> None: ...
    @property
    def showwhiskers(self) -> bool: ...
    @showwhiskers.setter
    def showwhiskers(self, val: bool) -> None: ...
    @property
    def sizemode(self) -> str: ...
    @sizemode.setter
    def sizemode(self, val: str) -> None: ...
    @property
    def stream(self) -> Stream | dict[str, int | str]: ...
    @stream.setter
    def stream(self, val: Stream | dict[str, int | str]) -> None: ...
    @property
    def text(
        self,
    ) -> str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]: ...
    @text.setter
    def text(
        self, val: str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
    ) -> None: ...
    @property
    def textsrc(self) -> str: ...
    @textsrc.setter
    def textsrc(self, val: str) -> None: ...
    @property
    def uid(self) -> str | int: ...
    @uid.setter
    def uid(self, val: str | int) -> None: ...
    @property
    def uirevision(self) -> Hashable: ...
    @uirevision.setter
    def uirevision(self, val: Hashable) -> None: ...
    @property
    def unselected(self) -> Unselected | dict[str, _unselected.Marker | dict[str, Any]]: ...
    @unselected.setter
    def unselected(self, val: Unselected | dict[str, _unselected.Marker | dict[str, Any]]) -> None: ...
    @property
    def upperfence(
        self,
    ) -> Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @upperfence.setter
    def upperfence(
        self,
        val: Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float],
    ) -> None: ...
    @property
    def upperfencesrc(self) -> str: ...
    @upperfencesrc.setter
    def upperfencesrc(self, val: str) -> None: ...
    @property
    def visible(self) -> bool | str: ...
    @visible.setter
    def visible(self, val: bool | str) -> None: ...
    @property
    def whiskerwidth(self) -> int | float: ...
    @whiskerwidth.setter
    def whiskerwidth(self, val: int | float) -> None: ...
    @property
    def width(self) -> int | float: ...
    @width.setter
    def width(self, val: int | float) -> None: ...
    @property
    def x(
        self,
    ) -> Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @x.setter
    def x(
        self,
        val: Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float],
    ) -> None: ...
    @property
    def x0(self) -> int | float: ...
    @x0.setter
    def x0(self, val: int | float) -> None: ...
    @property
    def xaxis(self) -> str: ...
    @xaxis.setter
    def xaxis(self, val: str) -> None: ...
    @property
    def xcalendar(self) -> str: ...
    @xcalendar.setter
    def xcalendar(self, val: str) -> None: ...
    @property
    def xhoverformat(self) -> str: ...
    @xhoverformat.setter
    def xhoverformat(self, val: str) -> None: ...
    @property
    def xperiod(self) -> int | float | str: ...
    @xperiod.setter
    def xperiod(self, val: int | float | str) -> None: ...
    @property
    def xperiod0(self) -> int | float | str: ...
    @xperiod0.setter
    def xperiod0(self, val: int | float | str) -> None: ...
    @property
    def xperiodalignment(self) -> str: ...
    @xperiodalignment.setter
    def xperiodalignment(self, val: str) -> None: ...
    @property
    def xsrc(self) -> str: ...
    @xsrc.setter
    def xsrc(self, val: str) -> None: ...
    @property
    def y(
        self,
    ) -> Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @y.setter
    def y(
        self,
        val: Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float],
    ) -> None: ...
    @property
    def y0(self) -> int | float: ...
    @y0.setter
    def y0(self, val: int | float) -> None: ...
    @property
    def yaxis(self) -> str: ...
    @yaxis.setter
    def yaxis(self, val: str) -> None: ...
    @property
    def ycalendar(self) -> str: ...
    @ycalendar.setter
    def ycalendar(self, val: str) -> None: ...
    @property
    def yhoverformat(self) -> str: ...
    @yhoverformat.setter
    def yhoverformat(self, val: str) -> None: ...
    @property
    def yperiod(self) -> int | float | str: ...
    @yperiod.setter
    def yperiod(self, val: int | float | str) -> None: ...
    @property
    def yperiod0(self) -> int | float | str: ...
    @yperiod0.setter
    def yperiod0(self, val: int | float | str) -> None: ...
    @property
    def yperiodalignment(self) -> str: ...
    @yperiodalignment.setter
    def yperiodalignment(self, val: str) -> None: ...
    @property
    def ysrc(self) -> str: ...
    @ysrc.setter
    def ysrc(self, val: str) -> None: ...
    @property
    def zorder(self) -> int: ...
    @zorder.setter
    def zorder(self, val: int) -> None: ...
    @property
    def type(self) -> str: ...
    def __init__(
        self,
        arg: Box | dict[str, Any] | None = ...,
        alignmentgroup: str | None = ...,
        boxmean: bool | str | None = ...,
        boxpoints: bool | str | None = ...,
        customdata: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float] | None = ...,
        customdatasrc: str | None = ...,
        dx: int | float | None = ...,
        dy: int | float | None = ...,
        fillcolor: str | None = ...,
        hoverinfo: str | Sequence[str] | None = ...,
        hoverinfosrc: str | None = ...,
        hoverlabel: Hoverlabel | dict[str, Any] | None = ...,
        hoveron: str | None = ...,
        hovertemplate: str
        | float
        | Sequence[str]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | None = ...,
        hovertemplatesrc: str | None = ...,
        hovertext: str
        | float
        | Sequence[str]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | None = ...,
        hovertextsrc: str | None = ...,
        ids: Sequence[str] | np.ndarray[tuple[int, ...], np.dtype[np.str_]] | pd.Series[str] | None = ...,
        idssrc: str | None = ...,
        jitter: int | float | None = ...,
        legend: str | None = ...,
        legendgroup: str | int | None = ...,
        legendgrouptitle: Legendgrouptitle | dict[str, Any] | None = ...,
        legendrank: int | float | None = ...,
        legendwidth: int | float | None = ...,
        line: Line | dict[str, str | int | float] | None = ...,
        lowerfence: Sequence[int]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | pd.Series[float]
        | None = ...,
        lowerfencesrc: str | None = ...,
        marker: Marker | dict[str, Any] | None = ...,
        mean: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float] | None = ...,
        meansrc: str | None = ...,
        median: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float] | None = ...,
        mediansrc: str | None = ...,
        meta: Sequence[Any] | dict[str, Any] | np.ndarray[tuple[int, ...], Any] | None = ...,
        metasrc: str | None = ...,
        name: str | int | None = ...,
        notched: bool | None = ...,
        notchspan: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float] | None = ...,
        notchspansrc: str | None = ...,
        notchwidth: int | float | None = ...,
        offsetgroup: str | int | None = ...,
        opacity: int | float | None = ...,
        orientation: str | None = ...,
        pointpos: int | float | None = ...,
        q1: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float] | None = ...,
        q1src: str | None = ...,
        q3: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float] | None = ...,
        q3src: str | None = ...,
        quartilemethod: str | None = ...,
        sd: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float] | None = ...,
        sdmultiple: int | float | None = ...,
        sdsrc: str | None = ...,
        selected: Selected | dict[str, _selected.Marker | dict[str, Any]] | None = ...,
        selectedpoints: Sequence[int] | None = ...,
        showlegend: bool | None = ...,
        showwhiskers: bool | None = ...,
        sizemode: str | None = ...,
        stream: Stream | dict[str, int | str] | None = ...,
        text: str
        | float
        | Sequence[str]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | None = ...,
        textsrc: str | None = ...,
        uid: str | int | None = ...,
        uirevision: Hashable | None = ...,
        unselected: Unselected | dict[str, _unselected.Marker | dict[str, Any]] | None = ...,
        upperfence: Sequence[int]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | pd.Series[float]
        | None = ...,
        upperfencesrc: str | None = ...,
        visible: bool | str | None = ...,
        whiskerwidth: int | float | None = ...,
        width: int | float | None = ...,
        x: Sequence[int]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | pd.Series[float]
        | None = ...,
        x0: int | float | None = ...,
        xaxis: str | None = ...,
        xcalendar: str | None = ...,
        xhoverformat: str | None = ...,
        xperiod: int | float | str | None = ...,
        xperiod0: int | float | str | None = ...,
        xperiodalignment: str | None = ...,
        xsrc: str | None = ...,
        y: Sequence[int]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | pd.Series[float]
        | None = ...,
        y0: int | float | None = ...,
        yaxis: str | None = ...,
        ycalendar: str | None = ...,
        yhoverformat: str | None = ...,
        yperiod: int | float | str | None = ...,
        yperiod0: int | float | str | None = ...,
        yperiodalignment: str | None = ...,
        ysrc: str | None = ...,
        zorder: int | None = ...,
        **kwargs: Any,
    ) -> None: ...
