from collections.abc import Hashable, Sequence
from typing import Any

import numpy as np
import pandas as pd
import plotly.graph_objs.scatter.selected as _selected
import plotly.graph_objs.scatter.unselected as _unselected
from plotly.basedatatypes import BaseTraceType as _BaseTraceType
from plotly.graph_objs.scatter import (
    ErrorX,
    ErrorY,
    Fillgradient,
    Fillpattern,
    Hoverlabel,
    Legendgrouptitle,
    Line,
    Marker,
    Selected,
    Stream,
    Textfont,
    Unselected,
)

class Scatter(_BaseTraceType):
    _parent_path_str = ...
    _path_str = ...
    _valid_props = ...
    @property
    def alignmentgroup(self) -> str | int: ...
    @alignmentgroup.setter
    def alignmentgroup(self, val: str | int) -> None: ...
    @property
    def cliponaxis(self) -> bool: ...
    @cliponaxis.setter
    def cliponaxis(self, val: bool) -> None: ...
    @property
    def connectgaps(self) -> bool: ...
    @connectgaps.setter
    def connectgaps(self, val: bool) -> None: ...
    @property
    def customdata(self) -> Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @customdata.setter
    def customdata(
        self, val: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]
    ) -> None: ...
    @property
    def customdatasrc(self) -> str: ...
    @customdatasrc.setter
    def customdatasrc(self, val: str) -> None: ...
    @property
    def dx(self) -> int | float: ...
    @dx.setter
    def dx(self, val: int | float) -> None: ...
    @property
    def dy(self) -> int | float: ...
    @dy.setter
    def dy(self, val: int | float) -> None: ...
    @property
    def error_x(self) -> ErrorX | dict[str, Any]: ...
    @error_x.setter
    def error_x(self, val: ErrorX | dict[str, Any]) -> None: ...
    @property
    def error_y(self) -> ErrorY | dict[str, Any]: ...
    @error_y.setter
    def error_y(self, val: ErrorY | dict[str, Any]) -> None: ...
    @property
    def fill(self) -> str: ...
    @fill.setter
    def fill(self, val: str) -> None: ...
    @property
    def fillcolor(self) -> str: ...
    @fillcolor.setter
    def fillcolor(self, val: str) -> None: ...
    @property
    def fillgradient(self) -> Fillgradient | dict[str, Any] | None: ...
    @fillgradient.setter
    def fillgradient(self, val: Fillgradient | dict[str, Any] | None) -> None: ...
    @property
    def fillpattern(self) -> Fillpattern | dict[str, Any]: ...
    @fillpattern.setter
    def fillpattern(self, val: Fillpattern | dict[str, Any]) -> None: ...
    @property
    def groupnorm(self) -> str: ...
    @groupnorm.setter
    def groupnorm(self, val: str) -> None: ...
    @property
    def hoverinfo(self) -> str | Sequence[str]: ...
    @hoverinfo.setter
    def hoverinfo(self, val: str | Sequence[str]) -> None: ...
    @property
    def hoverinfosrc(self) -> str: ...
    @hoverinfosrc.setter
    def hoverinfosrc(self, val: str) -> None: ...
    @property
    def hoverlabel(self) -> Hoverlabel | dict[str, Any]: ...
    @hoverlabel.setter
    def hoverlabel(self, val: Hoverlabel | dict[str, Any]) -> None: ...
    @property
    def hoveron(self) -> str: ...
    @hoveron.setter
    def hoveron(self, val: str) -> None: ...
    @property
    def hovertemplate(
        self,
    ) -> str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]: ...
    @hovertemplate.setter
    def hovertemplate(
        self, val: str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
    ) -> None: ...
    @property
    def hovertemplatesrc(self) -> str: ...
    @hovertemplatesrc.setter
    def hovertemplatesrc(self, val: str) -> None: ...
    @property
    def hovertext(
        self,
    ) -> str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]: ...
    @hovertext.setter
    def hovertext(
        self, val: str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
    ) -> None: ...
    @property
    def hovertextsrc(self) -> str: ...
    @hovertextsrc.setter
    def hovertextsrc(self, val: str) -> None: ...
    @property
    def ids(self) -> Sequence[str] | np.ndarray[tuple[int, ...], np.dtype[np.str_]] | pd.Series[str]: ...
    @ids.setter
    def ids(self, val: Sequence[str] | np.ndarray[tuple[int, ...], np.dtype[np.str_]] | pd.Series[str]) -> None: ...
    @property
    def idssrc(self) -> str: ...
    @idssrc.setter
    def idssrc(self, val: str) -> None: ...
    @property
    def legend(self) -> str: ...
    @legend.setter
    def legend(self, val: str) -> None: ...
    @property
    def legendgroup(self) -> str | int: ...
    @legendgroup.setter
    def legendgroup(self, val: str | int) -> None: ...
    @property
    def legendgrouptitle(self) -> Legendgrouptitle | dict[str, Any]: ...
    @legendgrouptitle.setter
    def legendgrouptitle(self, val: Legendgrouptitle | dict[str, Any]) -> None: ...
    @property
    def legendrank(self) -> int | float: ...
    @legendrank.setter
    def legendrank(self, val: int | float) -> None: ...
    @property
    def legendwidth(self) -> int | float: ...
    @legendwidth.setter
    def legendwidth(self, val: int | float) -> None: ...
    @property
    def line(self) -> Line | dict[str, str | int | float]: ...
    @line.setter
    def line(self, val: Line | dict[str, str | int | float]) -> None: ...
    @property
    def marker(self) -> Marker | dict[str, Any]: ...
    @marker.setter
    def marker(self, val: Marker | dict[str, Any]) -> None: ...
    @property
    def meta(self) -> Sequence[Any] | dict[str, Any] | np.ndarray[tuple[int, ...], Any]: ...
    @meta.setter
    def meta(self, val: Sequence[Any] | dict[str, Any] | np.ndarray[tuple[int, ...], Any]) -> None: ...
    @property
    def metasrc(self) -> str: ...
    @metasrc.setter
    def metasrc(self, val: str) -> None: ...
    @property
    def mode(self) -> str: ...
    @mode.setter
    def mode(self, val: str) -> None: ...
    @property
    def name(self) -> str | int: ...
    @name.setter
    def name(self, val: str | int) -> None: ...
    @property
    def offsetgroup(self) -> str | int: ...
    @offsetgroup.setter
    def offsetgroup(self, val: str | int) -> None: ...
    @property
    def opacity(self) -> int | float: ...
    @opacity.setter
    def opacity(self, val: int | float) -> None: ...
    @property
    def orientation(self) -> str: ...
    @orientation.setter
    def orientation(self, val: str) -> None: ...
    @property
    def selected(
        self,
    ) -> Selected | dict[str, _selected.Marker | _selected.Textfont | dict[str, Any]]: ...
    @selected.setter
    def selected(self, val: Selected | dict[str, _selected.Marker | _selected.Textfont | dict[str, Any]]) -> None: ...
    @property
    def selectedpoints(self) -> Sequence[int]: ...
    @selectedpoints.setter
    def selectedpoints(self, val: Sequence[int]) -> None: ...
    @property
    def showlegend(self) -> bool: ...
    @showlegend.setter
    def showlegend(self, val: bool) -> None: ...
    @property
    def stackgaps(self) -> str: ...
    @stackgaps.setter
    def stackgaps(self, val: str) -> None: ...
    @property
    def stackgroup(self) -> str | int: ...
    @stackgroup.setter
    def stackgroup(self, val: str | int) -> None: ...
    @property
    def stream(self) -> Stream | dict[str, int | str]: ...
    @stream.setter
    def stream(self, val: Stream | dict[str, int | str]) -> None: ...
    @property
    def text(
        self,
    ) -> str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]: ...
    @text.setter
    def text(
        self, val: str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
    ) -> None: ...
    @property
    def textfont(self) -> Textfont | dict[str, Any]: ...
    @textfont.setter
    def textfont(self, val: Textfont | dict[str, Any]) -> None: ...
    @property
    def textposition(self) -> str | Sequence[str] | np.ndarray[tuple[int, ...], np.dtype[np.str_]]: ...
    @textposition.setter
    def textposition(self, val: str | Sequence[str] | np.ndarray[tuple[int, ...], np.dtype[np.str_]]) -> None: ...
    @property
    def textpositionsrc(self) -> str: ...
    @textpositionsrc.setter
    def textpositionsrc(self, val: str) -> None: ...
    @property
    def textsrc(self) -> str: ...
    @textsrc.setter
    def textsrc(self, val: str) -> None: ...
    @property
    def texttemplate(
        self,
    ) -> str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]: ...
    @texttemplate.setter
    def texttemplate(
        self, val: str | float | Sequence[str] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
    ) -> None: ...
    @property
    def texttemplatesrc(self) -> str: ...
    @texttemplatesrc.setter
    def texttemplatesrc(self, val: str) -> None: ...
    @property
    def uid(self) -> str | int: ...
    @uid.setter
    def uid(self, val: str | int) -> None: ...
    @property
    def uirevision(self) -> Hashable: ...
    @uirevision.setter
    def uirevision(self, val: Hashable) -> None: ...
    @property
    def unselected(self) -> Unselected | dict[str, _unselected.Marker | _unselected.Textfont | dict[str, Any]]: ...
    @unselected.setter
    def unselected(
        self, val: Unselected | dict[str, _unselected.Marker | _unselected.Textfont | dict[str, Any]]
    ) -> None: ...
    @property
    def visible(self) -> bool | str: ...
    @visible.setter
    def visible(self, val: bool | str) -> None: ...
    @property
    def x(
        self,
    ) -> Sequence[Any] | np.ndarray[tuple[int, ...], np.dtype[Any]] | pd.Series[Any]: ...
    @x.setter
    def x(
        self,
        val: Sequence[Any] | np.ndarray[tuple[int, ...], np.dtype[Any]] | pd.Series[Any],
    ) -> None: ...
    @property
    def x0(self) -> int | float: ...
    @x0.setter
    def x0(self, val: int | float) -> None: ...
    @property
    def xaxis(self) -> str: ...
    @xaxis.setter
    def xaxis(self, val: str) -> None: ...
    @property
    def xcalendar(self) -> str: ...
    @xcalendar.setter
    def xcalendar(self, val: str) -> None: ...
    @property
    def xhoverformat(self) -> str: ...
    @xhoverformat.setter
    def xhoverformat(self, val: str) -> None: ...
    @property
    def xperiod(self) -> int | float | str: ...
    @xperiod.setter
    def xperiod(self, val: int | float | str) -> None: ...
    @property
    def xperiod0(self) -> int | float | str: ...
    @xperiod0.setter
    def xperiod0(self, val: int | float | str) -> None: ...
    @property
    def xperiodalignment(self) -> str: ...
    @xperiodalignment.setter
    def xperiodalignment(self, val: str) -> None: ...
    @property
    def xsrc(self) -> str: ...
    @xsrc.setter
    def xsrc(self, val: str) -> None: ...
    @property
    def y(
        self,
    ) -> Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float]: ...
    @y.setter
    def y(
        self,
        val: Sequence[int] | Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float],
    ) -> None: ...
    @property
    def y0(self) -> int | float: ...
    @y0.setter
    def y0(self, val: int | float) -> None: ...
    @property
    def yaxis(self) -> str: ...
    @yaxis.setter
    def yaxis(self, val: str) -> None: ...
    @property
    def ycalendar(self) -> str: ...
    @ycalendar.setter
    def ycalendar(self, val: str) -> None: ...
    @property
    def yhoverformat(self) -> str: ...
    @yhoverformat.setter
    def yhoverformat(self, val: str) -> None: ...
    @property
    def yperiod(self) -> int | float | str: ...
    @yperiod.setter
    def yperiod(self, val: int | float | str) -> None: ...
    @property
    def yperiod0(self) -> int | float | str: ...
    @yperiod0.setter
    def yperiod0(self, val: int | float | str) -> None: ...
    @property
    def yperiodalignment(self) -> str: ...
    @yperiodalignment.setter
    def yperiodalignment(self, val: str) -> None: ...
    @property
    def ysrc(self) -> str: ...
    @ysrc.setter
    def ysrc(self, val: str) -> None: ...
    @property
    def zorder(self) -> int: ...
    @zorder.setter
    def zorder(self, val: int) -> None: ...
    @property
    def type(self) -> str: ...
    def __init__(
        self,
        arg: Scatter | dict[str, Any] | None = ...,
        alignmentgroup: str | int | None = ...,
        cliponaxis: bool | None = ...,
        connectgaps: bool | None = ...,
        customdata: Sequence[float] | np.ndarray[tuple[int, ...], np.dtype[np.float64]] | pd.Series[float] | None = ...,
        customdatasrc: str | None = ...,
        dx: int | float | None = ...,
        dy: int | float | None = ...,
        error_x: ErrorX | dict[str, Any] | None = ...,
        error_y: ErrorY | dict[str, Any] | None = ...,
        fill: str | None = ...,
        fillcolor: str | None = ...,
        fillgradient: Fillgradient | dict[str, Any] | None = ...,
        fillpattern: Fillpattern | dict[str, Any] | None = ...,
        groupnorm: str | None = ...,
        hoverinfo: str | Sequence[str] | None = ...,
        hoverinfosrc: str | None = ...,
        hoverlabel: Hoverlabel | dict[str, Any] | None = ...,
        hoveron: str | None = ...,
        hovertemplate: str
        | float
        | Sequence[str]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | None = ...,
        hovertemplatesrc: str | None = ...,
        hovertext: str
        | float
        | Sequence[str]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | None = ...,
        hovertextsrc: str | None = ...,
        ids: Sequence[str] | np.ndarray[tuple[int, ...], np.dtype[np.str_]] | pd.Series[str] | None = ...,
        idssrc: str | None = ...,
        legend: str | None = ...,
        legendgroup: str | int | None = ...,
        legendgrouptitle: Legendgrouptitle | dict[str, Any] | None = ...,
        legendrank: int | float | None = ...,
        legendwidth: int | float | None = ...,
        line: Line | dict[str, str | int | float] | None = ...,
        marker: Marker | dict[str, Any] | None = ...,
        meta: Sequence[Any] | dict[str, Any] | np.ndarray[tuple[int, ...], Any] | None = ...,
        metasrc: str | None = ...,
        mode: str | None = ...,
        name: str | int | None = ...,
        offsetgroup: str | int | None = ...,
        opacity: int | float | None = ...,
        orientation: str | None = ...,
        selected: Selected | dict[str, _selected.Marker | _selected.Textfont | dict[str, Any]] | None = ...,
        selectedpoints: Sequence[int] | None = ...,
        showlegend: bool | None = ...,
        stackgaps: str | None = ...,
        stackgroup: str | int | None = ...,
        stream: Stream | dict[str, int | str] | None = ...,
        text: str | Sequence[str] | None = ...,
        textfont: Textfont | dict[str, Any] | None = ...,
        textposition: str | Sequence[str] | np.ndarray[tuple[int, ...], np.dtype[np.str_]] | None = ...,
        textpositionsrc: str | None = ...,
        textsrc: str | None = ...,
        texttemplate: str | None = ...,
        texttemplatesrc: str | None = ...,
        uid: str | int | None = ...,
        uirevision: Hashable | None = ...,
        unselected: Unselected | dict[str, _unselected.Marker | _unselected.Textfont | dict[str, Any]] | None = ...,
        visible: bool | str | None = ...,
        x: Sequence[Any] | np.ndarray[tuple[int, ...], np.dtype[Any]] | pd.Series[Any] | None = ...,
        x0: int | float | None = ...,
        xaxis: str | None = ...,
        xcalendar: str | None = ...,
        xhoverformat: str | None = ...,
        xperiod: int | float | str | None = ...,
        xperiod0: int | float | str | None = ...,
        xperiodalignment: str | None = ...,
        xsrc: str | None = ...,
        y: Sequence[int]
        | Sequence[float]
        | np.ndarray[tuple[int, ...], np.dtype[np.float64]]
        | pd.Series[float]
        | None = ...,
        y0: int | float | None = ...,
        yaxis: str | None = ...,
        ycalendar: str | None = ...,
        yhoverformat: str | None = ...,
        yperiod: int | float | str | None = ...,
        yperiod0: int | float | str | None = ...,
        yperiodalignment: str | None = ...,
        ysrc: str | None = ...,
        zorder: int | None = ...,
        **kwargs: Any,
    ) -> None: ...
